// Code generated by sqlc. DO NOT EDIT.
// source: queries.sql

package db

import (
	"context"
	"database/sql"
	"encoding/json"
)

const addNode = `-- name: AddNode :one
INSERT INTO nodes (resource_id, hostname, available) VALUES ($1, $2, $3) RETURNING resource_id, hostname, available
`

type AddNodeParams struct {
	ResourceID string
	Hostname   string
	Available  bool
}

func (q *Queries) AddNode(ctx context.Context, arg AddNodeParams) (Node, error) {
	row := q.db.QueryRowContext(ctx, addNode, arg.ResourceID, arg.Hostname, arg.Available)
	var i Node
	err := row.Scan(&i.ResourceID, &i.Hostname, &i.Available)
	return i, err
}

const addOpenwrt = `-- name: AddOpenwrt :one
INSERT INTO openwrts (openwrt_id) VALUES ($1) RETURNING openwrt_id
`

func (q *Queries) AddOpenwrt(ctx context.Context, openwrtID string) (string, error) {
	row := q.db.QueryRowContext(ctx, addOpenwrt, openwrtID)
	var openwrt_id string
	err := row.Scan(&openwrt_id)
	return openwrt_id, err
}

const attachVolumeToInstance = `-- name: AttachVolumeToInstance :execrows
UPDATE volumes SET instance = $1 WHERE resource_id = $2
`

type AttachVolumeToInstanceParams struct {
	Instance   sql.NullString
	ResourceID string
}

func (q *Queries) AttachVolumeToInstance(ctx context.Context, arg AttachVolumeToInstanceParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, attachVolumeToInstance, arg.Instance, arg.ResourceID)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}

const createInstance = `-- name: CreateInstance :exec
INSERT INTO instances (resource_id, base_image, memory, cpu, user_data, root_volume) VALUES ($1, $2, $3, $4, $5, $6)
`

type CreateInstanceParams struct {
	ResourceID string
	BaseImage  string
	Memory     int32
	Cpu        int32
	UserData   []byte
	RootVolume string
}

// INSTANCES
func (q *Queries) CreateInstance(ctx context.Context, arg CreateInstanceParams) error {
	_, err := q.db.ExecContext(ctx, createInstance,
		arg.ResourceID,
		arg.BaseImage,
		arg.Memory,
		arg.Cpu,
		arg.UserData,
		arg.RootVolume,
	)
	return err
}

const createJob = `-- name: CreateJob :exec
INSERT INTO jobs (job_id, assigned_worker, state, state_text, job_type, job_data) VALUES ($1, $2, $3, $4, $5, $6)
`

type CreateJobParams struct {
	JobID          string
	AssignedWorker string
	State          int32
	StateText      string
	JobType        string
	JobData        json.RawMessage
}

// JOBS
func (q *Queries) CreateJob(ctx context.Context, arg CreateJobParams) error {
	_, err := q.db.ExecContext(ctx, createJob,
		arg.JobID,
		arg.AssignedWorker,
		arg.State,
		arg.StateText,
		arg.JobType,
		arg.JobData,
	)
	return err
}

const createNetwork = `-- name: CreateNetwork :exec
INSERT INTO networks (resource_id, tenant, vlan_id) VALUES ($1, $2, $3)
`

type CreateNetworkParams struct {
	ResourceID string
	Tenant     string
	VlanID     int32
}

// NETWORKS
func (q *Queries) CreateNetwork(ctx context.Context, arg CreateNetworkParams) error {
	_, err := q.db.ExecContext(ctx, createNetwork, arg.ResourceID, arg.Tenant, arg.VlanID)
	return err
}

const createResource = `-- name: CreateResource :exec
INSERT INTO resources (resource_id, tenant) VALUES ($1, $2)
`

type CreateResourceParams struct {
	ResourceID string
	Tenant     string
}

// RESOURCES
func (q *Queries) CreateResource(ctx context.Context, arg CreateResourceParams) error {
	_, err := q.db.ExecContext(ctx, createResource, arg.ResourceID, arg.Tenant)
	return err
}

const createTenant = `-- name: CreateTenant :exec


INSERT INTO tenants (name, state) VALUES ($1, 0)
`

// Copyright 2021 Entanglement Garden Developers
// SPDX-License-Identifier: AGPL-3.0-only
// TENANTS
func (q *Queries) CreateTenant(ctx context.Context, name string) error {
	_, err := q.db.ExecContext(ctx, createTenant, name)
	return err
}

const createVolume = `-- name: CreateVolume :exec
INSERT INTO volumes (resource_id, node, size) VALUES ($1, $2, $3)
`

type CreateVolumeParams struct {
	ResourceID string
	Node       string
	Size       int32
}

// VOLUMES
func (q *Queries) CreateVolume(ctx context.Context, arg CreateVolumeParams) error {
	_, err := q.db.ExecContext(ctx, createVolume, arg.ResourceID, arg.Node, arg.Size)
	return err
}

const deleteInstance = `-- name: DeleteInstance :exec
DELETE FROM instances WHERE resource_id = $1
`

func (q *Queries) DeleteInstance(ctx context.Context, resourceID string) error {
	_, err := q.db.ExecContext(ctx, deleteInstance, resourceID)
	return err
}

const deleteJob = `-- name: DeleteJob :exec
DELETE FROM jobs WHERE job_id = $1
`

func (q *Queries) DeleteJob(ctx context.Context, jobID string) error {
	_, err := q.db.ExecContext(ctx, deleteJob, jobID)
	return err
}

const deleteNetwork = `-- name: DeleteNetwork :exec
DELETE FROM networks WHERE resource_id = $1
`

func (q *Queries) DeleteNetwork(ctx context.Context, resourceID string) error {
	_, err := q.db.ExecContext(ctx, deleteNetwork, resourceID)
	return err
}

const deleteNode = `-- name: DeleteNode :execrows
DELETE FROM nodes WHERE resource_id = $1
`

func (q *Queries) DeleteNode(ctx context.Context, resourceID string) (int64, error) {
	result, err := q.db.ExecContext(ctx, deleteNode, resourceID)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}

const deleteResource = `-- name: DeleteResource :exec
DELETE FROM resources WHERE resource_id = $1
`

func (q *Queries) DeleteResource(ctx context.Context, resourceID string) error {
	_, err := q.db.ExecContext(ctx, deleteResource, resourceID)
	return err
}

const deleteVolume = `-- name: DeleteVolume :exec
DELETE FROM volumes WHERE resource_id = $1
`

func (q *Queries) DeleteVolume(ctx context.Context, resourceID string) error {
	_, err := q.db.ExecContext(ctx, deleteVolume, resourceID)
	return err
}

const detachVolume = `-- name: DetachVolume :execrows
UPDATE volumes SET instance = NULL WHERE resource_id = $1
`

func (q *Queries) DetachVolume(ctx context.Context, resourceID string) (int64, error) {
	result, err := q.db.ExecContext(ctx, detachVolume, resourceID)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}

const getAllOpenwrtIDs = `-- name: GetAllOpenwrtIDs :many
SELECT openwrt_id FROM openwrts
`

func (q *Queries) GetAllOpenwrtIDs(ctx context.Context) ([]string, error) {
	rows, err := q.db.QueryContext(ctx, getAllOpenwrtIDs)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []string
	for rows.Next() {
		var openwrt_id string
		if err := rows.Scan(&openwrt_id); err != nil {
			return nil, err
		}
		items = append(items, openwrt_id)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getAvailableNodes = `-- name: GetAvailableNodes :many
SELECT resource_id FROM nodes WHERE available = true
`

func (q *Queries) GetAvailableNodes(ctx context.Context) ([]string, error) {
	rows, err := q.db.QueryContext(ctx, getAvailableNodes)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []string
	for rows.Next() {
		var resource_id string
		if err := rows.Scan(&resource_id); err != nil {
			return nil, err
		}
		items = append(items, resource_id)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getFailedJobs = `-- name: GetFailedJobs :many
SELECT job_id, created_at, assigned_worker, state, state_text, job_type, job_data FROM jobs WHERE state = 3
`

func (q *Queries) GetFailedJobs(ctx context.Context) ([]Job, error) {
	rows, err := q.db.QueryContext(ctx, getFailedJobs)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Job
	for rows.Next() {
		var i Job
		if err := rows.Scan(
			&i.JobID,
			&i.CreatedAt,
			&i.AssignedWorker,
			&i.State,
			&i.StateText,
			&i.JobType,
			&i.JobData,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getInstance = `-- name: GetInstance :one
SELECT resource_id, base_image, memory, cpu, node, state, user_data, root_volume FROM instances WHERE resource_id = $1
`

func (q *Queries) GetInstance(ctx context.Context, resourceID string) (Instance, error) {
	row := q.db.QueryRowContext(ctx, getInstance, resourceID)
	var i Instance
	err := row.Scan(
		&i.ResourceID,
		&i.BaseImage,
		&i.Memory,
		&i.Cpu,
		&i.Node,
		&i.State,
		&i.UserData,
		&i.RootVolume,
	)
	return i, err
}

const getInstanceAttachedVolumes = `-- name: GetInstanceAttachedVolumes :many
SELECT resource_id, node, size, instance FROM volumes WHERE instance = $1
`

func (q *Queries) GetInstanceAttachedVolumes(ctx context.Context, instance sql.NullString) ([]Volume, error) {
	rows, err := q.db.QueryContext(ctx, getInstanceAttachedVolumes, instance)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Volume
	for rows.Next() {
		var i Volume
		if err := rows.Scan(
			&i.ResourceID,
			&i.Node,
			&i.Size,
			&i.Instance,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getJob = `-- name: GetJob :one
SELECT job_id, created_at, assigned_worker, state, state_text, job_type, job_data FROM jobs WHERE job_id = $1
`

func (q *Queries) GetJob(ctx context.Context, jobID string) (Job, error) {
	row := q.db.QueryRowContext(ctx, getJob, jobID)
	var i Job
	err := row.Scan(
		&i.JobID,
		&i.CreatedAt,
		&i.AssignedWorker,
		&i.State,
		&i.StateText,
		&i.JobType,
		&i.JobData,
	)
	return i, err
}

const getNetwork = `-- name: GetNetwork :one
SELECT resource_id, tenant, vlan_id FROM networks WHERE resource_id = $1
`

func (q *Queries) GetNetwork(ctx context.Context, resourceID string) (Network, error) {
	row := q.db.QueryRowContext(ctx, getNetwork, resourceID)
	var i Network
	err := row.Scan(&i.ResourceID, &i.Tenant, &i.VlanID)
	return i, err
}

const getNextJob = `-- name: GetNextJob :one
SELECT job_id, created_at, assigned_worker, state, state_text, job_type, job_data FROM jobs WHERE state = 0
`

func (q *Queries) GetNextJob(ctx context.Context) (Job, error) {
	row := q.db.QueryRowContext(ctx, getNextJob)
	var i Job
	err := row.Scan(
		&i.JobID,
		&i.CreatedAt,
		&i.AssignedWorker,
		&i.State,
		&i.StateText,
		&i.JobType,
		&i.JobData,
	)
	return i, err
}

const getNextJobForWorker = `-- name: GetNextJobForWorker :one
SELECT job_id, created_at, assigned_worker, state, state_text, job_type, job_data FROM jobs WHERE state = 0 AND assigned_worker = $1
`

func (q *Queries) GetNextJobForWorker(ctx context.Context, assignedWorker string) (Job, error) {
	row := q.db.QueryRowContext(ctx, getNextJobForWorker, assignedWorker)
	var i Job
	err := row.Scan(
		&i.JobID,
		&i.CreatedAt,
		&i.AssignedWorker,
		&i.State,
		&i.StateText,
		&i.JobType,
		&i.JobData,
	)
	return i, err
}

const getNodeByHostname = `-- name: GetNodeByHostname :one
SELECT resource_id, hostname, available FROM nodes WHERE hostname = $1
`

func (q *Queries) GetNodeByHostname(ctx context.Context, hostname string) (Node, error) {
	row := q.db.QueryRowContext(ctx, getNodeByHostname, hostname)
	var i Node
	err := row.Scan(&i.ResourceID, &i.Hostname, &i.Available)
	return i, err
}

const getNodeForInstance = `-- name: GetNodeForInstance :one
SELECT nodes.resource_id, nodes.hostname, nodes.available FROM nodes, instances WHERE nodes.resource_id = instances.node AND instances.resource_id = $1
`

func (q *Queries) GetNodeForInstance(ctx context.Context, resourceID string) (Node, error) {
	row := q.db.QueryRowContext(ctx, getNodeForInstance, resourceID)
	var i Node
	err := row.Scan(&i.ResourceID, &i.Hostname, &i.Available)
	return i, err
}

const getNodes = `-- name: GetNodes :many
SELECT resource_id, hostname, available FROM nodes
`

// NODES
func (q *Queries) GetNodes(ctx context.Context) ([]Node, error) {
	rows, err := q.db.QueryContext(ctx, getNodes)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Node
	for rows.Next() {
		var i Node
		if err := rows.Scan(&i.ResourceID, &i.Hostname, &i.Available); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getOpenwrtByID = `-- name: GetOpenwrtByID :one
SELECT openwrt_id FROM openwrts WHERE openwrt_id = $1
`

// OPENWRTS
func (q *Queries) GetOpenwrtByID(ctx context.Context, openwrtID string) (string, error) {
	row := q.db.QueryRowContext(ctx, getOpenwrtByID, openwrtID)
	var openwrt_id string
	err := row.Scan(&openwrt_id)
	return openwrt_id, err
}

const listInstances = `-- name: ListInstances :many
SELECT instances.resource_id, instances.base_image, instances.memory, instances.cpu, instances.node, instances.state, instances.user_data, instances.root_volume FROM resources, instances WHERE resources.tenant = $1 AND resources.resource_id = instances.resource_id
`

func (q *Queries) ListInstances(ctx context.Context, tenant string) ([]Instance, error) {
	rows, err := q.db.QueryContext(ctx, listInstances, tenant)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Instance
	for rows.Next() {
		var i Instance
		if err := rows.Scan(
			&i.ResourceID,
			&i.BaseImage,
			&i.Memory,
			&i.Cpu,
			&i.Node,
			&i.State,
			&i.UserData,
			&i.RootVolume,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listNetworks = `-- name: ListNetworks :many
SELECT resource_id FROM networks
`

func (q *Queries) ListNetworks(ctx context.Context) ([]string, error) {
	rows, err := q.db.QueryContext(ctx, listNetworks)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []string
	for rows.Next() {
		var resource_id string
		if err := rows.Scan(&resource_id); err != nil {
			return nil, err
		}
		items = append(items, resource_id)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listTenants = `-- name: ListTenants :many
SELECT name, state FROM tenants
`

func (q *Queries) ListTenants(ctx context.Context) ([]Tenant, error) {
	rows, err := q.db.QueryContext(ctx, listTenants)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Tenant
	for rows.Next() {
		var i Tenant
		if err := rows.Scan(&i.Name, &i.State); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listVolumes = `-- name: ListVolumes :many
SELECT volumes.resource_id, volumes.node, volumes.size, volumes.instance FROM resources, volumes WHERE resources.tenant = $1 AND resources.resource_id = volumes.resource_id
`

func (q *Queries) ListVolumes(ctx context.Context, tenant string) ([]Volume, error) {
	rows, err := q.db.QueryContext(ctx, listVolumes, tenant)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Volume
	for rows.Next() {
		var i Volume
		if err := rows.Scan(
			&i.ResourceID,
			&i.Node,
			&i.Size,
			&i.Instance,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const setInstanceState = `-- name: SetInstanceState :exec
UPDATE instances SET state = $1 WHERE resource_id = $2
`

type SetInstanceStateParams struct {
	State      int32
	ResourceID string
}

func (q *Queries) SetInstanceState(ctx context.Context, arg SetInstanceStateParams) error {
	_, err := q.db.ExecContext(ctx, setInstanceState, arg.State, arg.ResourceID)
	return err
}

const setJobState = `-- name: SetJobState :execrows
UPDATE jobs SET state = $1, state_text = $2 WHERE job_id = $3
`

type SetJobStateParams struct {
	State     int32
	StateText string
	JobID     string
}

func (q *Queries) SetJobState(ctx context.Context, arg SetJobStateParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, setJobState, arg.State, arg.StateText, arg.JobID)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}

const setNodeAvailability = `-- name: SetNodeAvailability :execrows
UPDATE nodes SET available = $1 WHERE hostname = $2
`

type SetNodeAvailabilityParams struct {
	Available bool
	Hostname  string
}

func (q *Queries) SetNodeAvailability(ctx context.Context, arg SetNodeAvailabilityParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, setNodeAvailability, arg.Available, arg.Hostname)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}

const setNodeForInstance = `-- name: SetNodeForInstance :execrows
UPDATE instances SET node = $1 WHERE resource_id = $2
`

type SetNodeForInstanceParams struct {
	Node       sql.NullString
	ResourceID string
}

func (q *Queries) SetNodeForInstance(ctx context.Context, arg SetNodeForInstanceParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, setNodeForInstance, arg.Node, arg.ResourceID)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}

const setNodeHostname = `-- name: SetNodeHostname :execrows
UPDATE nodes SET hostname = $1 WHERE resource_id = $2
`

type SetNodeHostnameParams struct {
	Hostname   string
	ResourceID string
}

func (q *Queries) SetNodeHostname(ctx context.Context, arg SetNodeHostnameParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, setNodeHostname, arg.Hostname, arg.ResourceID)
	if err != nil {
		return 0, err
	}
	return result.RowsAffected()
}
